--## Choco ##--

Choco = Choco or {util={}}

--[[Converts a string to a table, breaking the string up at every occurance of the separation pattern
* (string) str = String to convert to a table
* (string) sep = Separation pattern to split up string
* (boolean) [plain] = if true then ignore pattern matching for sep (optional)
* (boolean) [reverse] = if true then insert substrings into table in reverse order (optional) ]]
local function str2tbl(str, sep, plain, reverse)
	local version = 1.0
	local date = '2010-06-09'
	if str=='#VERSION' and sep==nil then return version end
	
	local tbl = {} --table to return
	if type(str)=='string' then
		if type(sep)=='string' and sep:len()>=1 then
			if reverse then str = str:reverse() end
			
			local i,n = 1,nil
			while i and i<=str:len() do
				
				local start = i --first index of substring
				n,i = str:find(sep, start, plain) --next occurance of sep
				local stop = n and n-1 --last index of substring
				
				local sub = str:sub(start, stop)
				if reverse then sub = sub and sub:reverse() end --undo reversal
				table.insert(tbl, sub)
				
				i = i and i+1 --index to begin next substring
			end
			
			return tbl
		else return nil end
	else return nil end
end
if str2tbl('#VERSION') > (Choco.util.str2tbl and Choco.util.str2tbl('#VERSION') or 0) then Choco.util.str2tbl=str2tbl end